#!/usr/bin/env python
#
# $Id: test_nested_structures.py,v 1.1 2002/11/17 14:51:44 doughellmann Exp $
#
# Time-stamp: <01/03/08 02:13:53 dhellmann>
#
# Copyright 2001 Doug Hellmann.
#
#
#                         All Rights Reserved
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby
# granted, provided that the above copyright notice appear in all
# copies and that both that copyright notice and this permission
# notice appear in supporting documentation, and that the name of Doug
# Hellmann not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission.
#
# DOUG HELLMANN DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
# INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN
# NO EVENT SHALL DOUG HELLMANN BE LIABLE FOR ANY SPECIAL, INDIRECT OR
# CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
# OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
# NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
# CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#

"""Test various nested structures.


      o Jerome Alet <alet@unice.fr> reported that nested classes do
        not appear in the output.

      o Jerome Alet <alet@unice.fr> reported that nested functions do
        not appear in the output.
  

"""

__rcs_info__ = {
    #
    #  Creation Information
    #
    'module_name'  : '$RCSfile: test_nested_structures.py,v $',
    'rcs_id'       : '$Id: test_nested_structures.py,v 1.1 2002/11/17 14:51:44 doughellmann Exp $',
    'creator'      : 'Doug Hellmann <DougHellmann@bigfoot.com>',
    'project'      : 'HappyDoc',
    'created'      : 'Thu, 08-Mar-2001 02:08:06 EST',

    #
    #  Current Information
    #
    'author'       : '$Author: doughellmann $',
    'version'      : '$Revision: 1.1 $',
    'date'         : '$Date: 2002/11/17 14:51:44 $',
}

#
# Import system modules
#


#
# Import Local modules
#


#
# Module
#

class OuterClass:
    """This class is on the outside.

    This class contains one nested class.
    """

    class InnerClass:
        """This class is inside of OuterClass.

        This class is nested one level deep.
        """

        class InnerClass2:
            """This class is inside of InnerClass.

            This class is nested two levels deep.
            """


def OuterFunction():
    "This function is at the outer level."

    def InnerFunction():
        "This function is inside of OuterFunction."

        def InnerFunction2():
            "This function is inside of InnerFunction."

